package cz.upol.fpj.lecture10

object ControlStuctures {
  def main(args: Array[String]): Unit = {
    whileLoops()
    forLoops()
    forLoopsFn()
  }
  
  // funkcionalnejsi pouzit for-cyklu
  def forLoopsFn() {
    val evens = for (i <- 1 to 10)
      yield i * 2
    println(evens)
    
    val bs = for (a <- Array("foo", "bar", "baz", "qux");
        if (a.startsWith("b")))
      yield a.toUpperCase()
    
    println(bs mkString " ")
  }
  
  // tradicni pouziti for-loop
  def forLoops() {
    // iterace pres jednu promennou
    for (i <- 1 to 10) {
      println(i)
    }
    
    // lze pouzit kolekce
    for (i <- Array(10, 20, 30, 40)) {
      println(i)
    }
    
    // lze pouzit i vice promennych
    for (i <- 1 to 10; j <- 1 to 10) {
      println(i * j)
    }
    
    // lze pouzit i podminky
    for (i <- 1 to 10; if ((i % 2) == 0)) {
      println(i)
    }
  }
  
  // cyklus while je sice k dispozici, ale jeho pouziti neni moc funcionalni
  def whileLoops() = {
    var i = 0;
    while (i < 10) {
      println(i)
      i += 1
    }

    do {
      println(i)
      i -= 1;
    } while (i > 0);
  }
}