package cz.upol.fpj.lecture10

object HOF {
  def makeInc(n: Int): Int => Int =
    x => x + n;
    
  def arrayApply(xs: Array[Int], f: Int => Int) =
    xs.map(f)
    
  val ints = Array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)
    
  def main(args: Array[String]): Unit = {
    val inc = makeInc(1)
    val inc2 = makeInc(2)
    
    println(inc(10))
    println(inc2(20))
    
    // funkce je objekt
    println(inc.apply(10))
    
    println(arrayApply(ints, makeInc(100)).mkString(" "))
    println(ints.map(x => x + 1).mkString(" "))
    
    // zkracena forma -- kazde _ jeden argument
    println(ints.map(_ + 1).mkString(" "))
    ints.map(_ + 1).foreach(println _)
    
    val f = (_: Int) + (_: Int)
    println(f(10, 20))
    
    
    
    
    // castecna aplikace
    def sum(a: Int, b: Int, c: Int) = a + b + c;
    val sum2 = sum(10, _: Int, _: Int);
    println(sum2(1, 2));
    
    
    
    
  }
}