package cz.upol.fpj.lecture10

object Match {
  
  def fib(n: Int): Int = n match {
    case 0 => 0
    case 1 => 1
    case _ => fib(n - 1) + fib(n - 2)
  }
  
  def and(a: Int, b: Int) = (a, b) match {
    case (0, _) => 0
    case (_, 0) => 0
    case _ => 1
  }
  
  def abs(a: Any) = a match {
    case x: Int => if (x >= 0) x else -x
    case x: String => x.length()
    case (a: Int, i: Int) => Math.sqrt(a * a + i * i)
    case _ => Double.NaN
  }
  
  def main(args: Array[String]): Unit = {
    println(fib(30))
    println(and(1, 0))
    println(abs(-10))
    println(abs("abc"))
    println(abs((2, 3)))
  }
}